//+------------------------------------------------------------------+
//|                                                     .mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "wfy05@talkforex.com"
#property link      "www.talkforex.com"

//---- input parameters
extern bool      Enabled=true;
extern bool      UseBid=true;
extern int       SpeakInterval=10;
extern bool      SpeakSymbol=true;
extern int       SpeakDelta=1;
extern double    Range1Min=0.0;
extern double    Range1Max=99999.9;
extern double    Range2Min=0.0;
extern double    Range2Max=0.0;
extern bool      InitSpeak=false;
extern bool      LogMessage=false;

double LastPrice = 0;
int LastSpeakTime = 0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

double GetCurrPrice()
{
   double p;
      
   if (UseBid) {
      p = Bid;
   } else {
      p = Ask;
   }
   return (p);
}

string CurrencyGetName(string c)
{
   if (c == "USD") {
      return ("Ԫ");
   } else if (c == "EUR") {
      return ("ŷԪ");
   } else if (c == "GBP") {
      return ("Ӣ");
   } else if (c == "JPY") {
      return ("Ԫ");
   } else if (c == "CAD") {
      return ("Ԫ");
   } else if (c == "CHF") {
      return ("");
   } else if (c == "AUD") {
      return ("Ԫ");
   } else if (c == "SGD") {
      return ("Ԫ");
   } else if (c == "NZD") {
      return ("ŦԪ");
   } else if (c == "HKD") {
      return ("۱");
   } else if (c == "CNY") {
      return ("");
   } else {
      return ("");
   }               
}

string GetSymbolName(string name)
{
   string str;
   
   str = "";
   if (StringLen(name) != 6) {
      if (name == "USDX" || name == "_DXY") {
         str = str+"Ԫָ";
      } else if (name == "GOLD") {
         str = str+"ƽ";
      }         
   } else {
      string left, right;
      left = CurrencyGetName(StringSubstr(name, 0, 3));
      right = CurrencyGetName(StringSubstr(name, 3, 3));
      if (left != "" && right != "") {
         str = str+(left + "" + right);
      }
   }
   return (str);
}

string GetSpeechText()
{
   string str;
   
   str = "";
   if (SpeakSymbol) {
      str = str + GetSymbolName(Symbol());
      if (str != "") {
         if (UseBid) {
            str = str+"Ϊ";
         } else {
            str = str+"Ϊ";
         }            
      }      
   }
   double p;   
   p = GetCurrPrice();
   str = str+DoubleToStr(p, Digits);
   if (SpeakDelta != 0 ) {
      int n = MathPow(10, Digits);
      double diff = MathAbs(p*n-LastPrice*n);
      if (diff >= SpeakDelta) {
         if (p > LastPrice) {
            str = str+""+DoubleToStr(diff,0)+"";
         } else {
            str = str+"µ"+DoubleToStr(diff,0)+"";
         }
      }
//      Print(LastPrice + "->" + p + " : " + diff);
   }
   LastPrice = p;
   if (LogMessage) Print (str);
   return (str);
}

int init()
  {
//----
//----
   LastPrice = GetCurrPrice();
   LastSpeakTime = 0;
   
   if (InitSpeak) {
      string str;   
      str = "ʼ" + GetSymbolName(Symbol()) + "Զ,";
      str = str + "ǰ۸Ϊ" + DoubleToStr(LastPrice, Digits);
      SpeechText(str, SPEECH_NATIVE);
   }      
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   if (InitSpeak) {
      string str;
      str = "ֹͣ" + GetSymbolName(Symbol()) + "Զ";
      SpeechText(str, SPEECH_NATIVE);
   }      
//----
   return(0);
  }  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   if (!Enabled) return (0);
   double p = GetCurrPrice();
   if (MathAbs(GetTickCount() - LastSpeakTime) < SpeakInterval * 1000) {
      return (0);
   }
   if ((p >= Range1Min && p <= Range1Max) || (p >= Range2Min && p <= Range2Max)) {
      SpeechText(GetSpeechText(), SPEECH_NATIVE);
      LastSpeakTime = GetTickCount();
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+